// -*- Mode: Go; indent-tabs-mode: t -*-

/*
 * Copyright (C) 2016 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package dbus_test

import (
	"testing"

	. "gopkg.in/check.v1"

	"github.com/snapcore/snapd/interfaces/dbus"
)

func Test(t *testing.T) {
	TestingT(t)
}

type dBusSuite struct{}

var _ = Suite(&dBusSuite{})

func (s *dBusSuite) TestSecurityGenDbusPath(c *C) {
	c.Assert(dbus.SafePath("foo"), Equals, "foo")
	c.Assert(dbus.SafePath("foo bar"), Equals, "foo_20bar")
	c.Assert(dbus.SafePath("foo/bar"), Equals, "foo_2fbar")
}
